<template>
  <div>
    <skm-header
      :group-id="id"
      ref="header"
      @search-click="handleHeaderOpenBranchSelectorPopup"
    >
      <div class="filter-container d-md-none" v-if="isListView">
        <div class="filter-fixed-container">
          <div class="container">
            <div class="primary-filter-container">
              <div class="row justify-content-center tabs">
                <div class="col col-12 text-center tabs__title">
                  {{
                    $t("preorderTutorial.detailItem.selectRestaurant.service")
                  }}：
                </div>
                <div v-for="(tab, key) in tabs" class="col col-auto" :key="key">
                  <label class="d-block tab" :class="`tab--${key}`">
                    <input
                      class="d-none"
                      type="checkbox"
                      v-model="filter.service[key]"
                      :true-value="true"
                      :false-value="false"
                      :disabled="filter.service[key] == 'disabled'"
                    />
                    <i class="d-block tab__check">&#10003;</i>
                    <span class="d-block tab__cube">
                      <img :src="`/static/images/icons/${key}.png`" alt="" />
                      <span class="d-block text-white ">{{ tab }}</span>
                    </span>
                  </label>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div v-if="isPreorderView">
        <div class="container flex md-flex-row2column">
          <preorder-date-selector
            @dateChanged="preorderDateChanged"
            @timeChanged="preorderTimeChanged"
            :time="preorderTime"
            :date="preorderDate"
            :times="preorderTimes"
            :dates="preorderDates"
          />
          <div
            class="preorder-tutorial-entrance"
            @click.stop.prevent="openPreorderTutorialPage()"
          >
            <div class="icon"></div>
            <div class="label">{{ $t("preorderTutorial.entranceText") }}</div>
          </div>
          <span class="needhelp-label"
            >{{ $t("preorderTutorial.needHelp") }}
            <a class="tutorial-link" href="/preorder-tutorial">{{
              $t("preorderTutorial.entranceText")
            }}</a>
          </span>
        </div>
      </div>
    </skm-header>
    <template v-if="isListView">
      <restaurant-filter />
      <!-- <div
        class="fixed-top-filter d-md-none"
        :class="{ 'fixed-top-filter--show': showFixedFilter }"
      >
        <div class="container m-container-no-gutter">
          <primary-filter />
          <restaurant-filter />
        </div>
      </div> -->
    </template>
    <router-view :group="group" :restaurants="restaurants"></router-view>
  </div>
</template>
<script>
import moment from "moment";
import * as utils from "@/utils";
import SkmHeader from "@/components/Header";
import * as groupPresenter from "@/presenters/group";
import { mapGetters, mapState, mapActions, mapMutations } from "vuex";
import PrimaryFilter from "@/components/Group/PrimaryFilter";
import RestaurantFilter from "@/components/Group/RestaurantFilter";
import PreorderDateSelector from "@/components/Group/PreorderDateSelector";
import BranchSelector from "@/components/BranchSelector";
import PopupFull from "@/components/PopupFull";
import store from "@/store";
import capitalize from "lodash/capitalize";

export default {
  async beforeRouteEnter(to, from, next) {
    try {
      await store.dispatch("branch/getBranches");
      await store.dispatch("branch/getAreas");

      next();
    } catch (err) {
      next();
      // NOTE: handle error below.
    }
  },
  beforeRouteLeave(to, from, next) {
    if (to.name === "RestaurantDelivery") {
      console.log(to.params);
      // 檢查現在分店是否符合地址的外送範圍
      if (this.isMatchDeliveryScope) {
        if (to.query.time && to.query.date) {
          next();
        } else {
          this.openBranchSelectorPopup({
            isDeliveryPopup: true,
            companyId: to.params.companyId,
            id: to.params.id
          });
        }
      } else {
        this.openBranchSelectorPopup({
          isDeliveryPopup: true,
          companyId: to.params.companyId,
          id: to.params.id
        });
      }
    } else {
      next();
    }
  },
  props: {
    id: {
      type: String,
      required: true
    }
  },
  data() {
    const { time, date } = this.$route.query;
    return {
      showFixedFilter: false,
      selectedPreorderTime: time,
      selectedPreorderDate: date ? moment(date, "YYYY-MM-DD").toDate() : null,
      branchSelector: {
        companyId: null,
        isDelivery: false
      }
    };
  },
  watch: {
    groupId() {
      this.fetchGroup();
    }
  },
  computed: {
    ...mapState("group", ["group", "restaurants", "filter"]),

    ...mapState("branch", {
      selection: "select",
      showBranchSelectorPopup: "showBranchSelectorPopup",
      isMatchDeliveryScope: "isMatchDeliveryScope"
    }),

    ...mapGetters({
      branchOptions: "branch/branchOptions",
      cityOptions: "branch/cityOptions",
      areaOptions: "branch/areaOptions"
    }),
    tabs() {
      return this.$t("restaurant.tab");
    },
    preorderDate() {
      return this.selectedPreorderDate || this.preorderDates[0];
    },

    preorderTime() {
      return this.selectedPreorderTime || this.preorderTimes[0];
    },

    preorderDates() {
      return groupPresenter.preorderDates();
    },

    isToday() {
      const date = moment(this.preorderDate).add(3, "hours");
      return utils.isToday(date.toDate());
    },

    preorderTimes() {
      return groupPresenter.preorderTimes(this.isToday, this.restaurants);
    },

    groupId() {
      return this.$route.params.groupId;
    },

    isListView() {
      return this.$route.name === "Group";
    },

    isMapView() {
      return this.$route.name === "GroupMap";
    },

    isPreorderView() {
      return this.$route.name === "GroupPreorder";
    },

    preorderRestaurants() {
      return this.selectedPreorderTime
        ? this.restaurants.filter(restaurant =>
            restaurant
              .preorderTimes(this.isToday)
              .find(this.selectedPreorderTime)
          )
        : this.restaurants;
    },
    filterRestaurants() {
      return this.restaurants.filter(x => x.webBookingEnabled === false);
    }
  },
  components: {
    SkmHeader,
    RestaurantFilter,
    PrimaryFilter,
    PreorderDateSelector,
    BranchSelector,
    PopupFull
  },
  methods: {
    ...mapActions("group", ["updateFilter", "loadGroup", "clear"]),
    ...mapActions("branch", [
      "checkDelivery",
      "openBranchSelectorPopup",
      "closeBranchSelectorPopup",
      "resetSelectorCurrent"
    ]),

    updateFixedFilter() {
      if (this.$refs.header && this.$refs.header.$el) {
        this.showFixedFilter =
          this.$refs.header.$el.getBoundingClientRect().bottom <= 0;
      }
    },
    initFixedFilter() {
      window.addEventListener("scroll", this.updateFixedFilter);
    },
    fetchGroup() {
      this.updateFilter({ groupId: this.$route.params.groupId });
    },

    preorderDateChanged(date) {
      this.selectedPreorderDate = date;
      this.updateFilter({ date: moment(date).format("YYYY-MM-DD") });
      this.$router.push({
        query: {
          ...this.$route.query,
          date: moment(date).format("YYYY-MM-DD")
        }
      });
    },

    preorderTimeChanged(time) {
      this.selectedPreorderTime = time;
      this.$router.push({
        query: {
          ...this.$route.query,
          time
        }
      });
    },

    openPreorderTutorialPage() {
      this.$router.push(`/preorder-tutorial`);
    },

    handleHeaderOpenBranchSelectorPopup() {
      this.openBranchSelectorPopup();
    }
  },
  mounted() {
    this.fetchGroup();
    this.initFixedFilter();

    window.gtag("event", "Landing page - Enter", {
      event_label: JSON.stringify({ group_id: this.id })
    });
    window.gtag("event", "pageview", {
      event_category: "美食地圖分店",
      event_label: this.$i18n.t(`group.${this.id}`)
    });
  },
  created() {
    this.resetSelectorCurrent();
  },
  destroyed() {
    if (this.clear) {
      this.clear();
    }
    window.removeEventListener("scroll", this.updateFixedFilter);
  }
};
</script>
<style lang="scss" scoped>
.primary-filter-container {
  max-width: 540px;
  margin: auto;
  @include media-breakpoint-up(xl) {
    margin: 0;
  }
}

.fixed-top-filter {
  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  background-color: $color-white;
  z-index: 1000;
  box-shadow: 0 4px 4px 0 rgba(0, 0, 0, 0.05),
    inset 0 -1px 0 0 $color-silver-grey;
  pointer-events: none;
  opacity: 0;
  transform: translateY(-100%);
  transition: opacity 0.2s, transform 0.5s;

  &--show {
    opacity: 1;
    transform: none;
    pointer-events: auto;
  }
}

.preorder-tutorial-entrance {
  display: none;
  @include media-breakpoint-up(md) {
    width: 96px;
    height: 90px;
    margin-top: 12px;
    margin-left: 7px;
    background-color: $color-white;
    box-shadow: 0 4px 4px 0 rgba(0, 0, 0, 0.05);
    display: inline-block;
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    cursor: pointer;
    .icon {
      width: 32px;
      height: 32px;
      background: url("/static/images/preorder-tutorial/ic-takeout-desc.svg");
      margin-bottom: 3px;
    }
  }

  @include media-breakpoint-up(lg) {
    height: 100px;
    margin-top: 0;
  }
}

.needhelp-label {
  margin-top: 20px;
  .tutorial-link {
    text-decoration: underline;
    color: $color-skm-red;
    &:hover {
      text-decoration: underline;
    }
  }
  @include media-breakpoint-up(md) {
    display: none;
  }
}

.tabs {
  font-size: 14px;
  &__title {
    margin-bottom: 10px;
    color: #fff;
  }
  .col {
    padding: 0 4px;
  }
  .tab {
    margin: 0;
    cursor: pointer;

    &--btn {
      background-color: $white;
      text-align: center;
      *vertical-align: middle;
      padding: 10px 0;
      margin-bottom: 0;
      border-radius: 4px;
      box-shadow: 0px 0px 10px 7px rgba(0, 0, 0, 0.1);
      color: $color-primary-black;

      img {
        margin-right: 4px;
      }
    }

    img {
      width: 20px;
    }
    &__check {
      width: 14px;
      height: 14px;
      margin: 0 auto 5px;
      border-radius: 14px;
      background-color: map_get($tab-colors, "default");
      transition: background 0.15s ease-in;
      font-size: 12px;
      color: $white;
      text-indent: -1px;
      line-height: 1.2;
    }

    &__cube {
      border-radius: 2px;
      width: (115px / 2);
      height: (92px / 2);
      background-color: map_get($tab-colors, "default");
      transition: background 0.15s ease-in;
    }

    input:disabled ~ {
      .tab__cube {
        color: map_get($tab-colors, "default") !important;
      }
      .tab__cube,
      .tab__check {
        cursor: not-allowed;
        background-color: map_get($tab-colors, "default") !important;
      }
    }

    &--booking {
      input:checked ~ {
        .tab__cube,
        .tab__check {
          background-color: map_get($tab-colors, "booking");
        }
      }
      &.tab--btn {
        border-bottom: 2px solid map_get($tab-colors, "booking");
      }
    }

    &--waiting {
      input:checked ~ {
        .tab__cube,
        .tab__check {
          background-color: map_get($tab-colors, "waiting");
        }
      }
      &.tab--btn {
        border-bottom: 2px solid map_get($tab-colors, "waiting");
      }
    }

    &--preorder {
      input:checked ~ {
        .tab__cube,
        .tab__check {
          background-color: map_get($tab-colors, "preorder");
        }
      }

      &.tab--btn {
        border-bottom: 2px solid map_get($tab-colors, "preorder");
      }
    }

    &--delivery {
      input:checked ~ {
        .tab__cube,
        .tab__check {
          background-color: map_get($tab-colors, "delivery");
        }
      }

      &.tab--btn {
        border-bottom: 2px solid map_get($tab-colors, "delivery");
      }
    }
  }
}

.branch-selector-popup {
  @include media-breakpoint-up(md) {
    margin-top: -40%;
  }

  &::v-deep {
    height: 100%;
    @include media-breakpoint-up(md) {
      height: auto;
    }
    .branch-selector-box {
      top: 0;
      left: 0;
      height: 100%;
      background-color: $white;
      @include media-breakpoint-up(md) {
        height: auto;
      }
    }
    .result-box {
      display: block;
      background-color: $white;
      @include media-breakpoint-up(md) {
        display: flex;
        left: 50%;
      }
    }
    .result-content--noResult {
      padding: 0 4%;
    }
  }
}
</style>
